; dict.asm
;
; Words to play with dictionaries. Hashing algorithm stolen from IsForth. 

; hash ( string -- hash*4 )
core_header 26,_hash,"hash",flag_none
_hash:
	mov	al,[ebx]		; al = string length
	mov	bx,[ebx+1]		; bl,bh = first and second chars
	shl	bl,1			; hash = first char * 2
	cmp	al,1			; is length 1?
	jz	.done			; yes, we're done here
	add	bl,bh			; add next char to hash
	shl	bl,1			; double hash
.done:	add	al,bl			; add length to hash
	and	al,0x3f			; we only want the 6 low bits
	movzx	ebx,al			; zero extend hash
	shl	ebx,2			; 4* for use in lookup tables
	next
 
