; fdc.asm
;
; Floppy disk routines.

fdc_init:
	mov	eax,0x26		; set interrupt 0x26 (IRQ 6) handler
	mov	ebx,fdc_irq6
	call	idt_set_int
	mov	cl,6
	call	irq_enable		; enable IRQ 6
	ret

fdc_irq6:
	push	eax
	mov	dword[fdc_done],-1	; set the "done" flag
	mov	al,0x20
	out	0x20,al			; send ack to PIC
	pop	eax
	iret

core_header 28,_fdc_done,"fdc-done",flag_none
_fdc_done:
	call	_dovar
fdc_done	dd	0

core_header 26,_fdc_to,"fdc-to",flag_none
_fdc_to:
	call	_dovar
fdc_timeout	dd	0

