; logic.f
;
; Words for comparing values. Bit logic is in math.asm

core_header 3b,_eq,"=",flag_none
_eq:
	pop	eax			; eax = NOS
	cmp	eax,ebx			; NOS = TOS?
	jnz	.false
	mov	ebx,-1			; yes, return true
	next
.false:	xor	ebx,ebx			; no, return false
	next

core_header 3c,_0eq,"0=",flag_none
_0eq:
	or	ebx,ebx			; TOS = 0?
	jnz	.false
	dec	ebx			; return -1 (true)
	next
.false:	xor	ebx,ebx			; no, return false
	next

core_header 2e,_neq,"<>",flag_none
_neq:
	pop	eax			; eax = NOS
	cmp	eax,ebx			; NOS <> TOS?
	jz	.false
	mov	ebx,-1			; yes, return true
	next
.false:	xor	ebx,ebx			; no, return false
	next

core_header 3d,_ab,">",flag_none
_ab:
	pop	eax			; eax = NOS
	cmp	eax,ebx			; NOS > TOS?
	jna	.false
	mov	ebx,-1			; yes, return true
	next
.false:	xor	ebx,ebx			; no, return false
	next

core_header 39,_be,"<",flag_none
_be:
	pop	eax			; eax = NOS
	cmp	eax,ebx			; NOS < TOS?
	jnb	.false
	mov	ebx,-1			; yes, return true
	next
.false:	xor	ebx,ebx			; no, return false
	next

