; gdt.asm
;
; Just a few functions to deal with the global descriptor table.

gdt_init:
	lgdt	[gdt_descriptor]
	mov	ax,0x10
	mov	ds,ax
	mov	es,ax
	mov	ss,ax
	mov	fs,ax
	mov	gs,ax
	jmp	8:.new_cs
.new_cs:
	ret

gdt:
.dummy	times 8 db 0
.codeseg:
	dw	0xffff,0x0000
	db	0x00,0x9a,0xcf,0x00
.dataseg:
	dw	0xffff,0x0000
	db	0x00,0x92,0xcf,0x00
.end:	

gdt_descriptor:
.size		dw	(gdt.end - gdt) - 1
.pointer	dd	gdt

