; jump.asm
;
; Various words for jumping around in the program.

core_header 32,_branch,"branch",flag_none
_branch:
	lodsd				; eax = new IP
	xchg	eax,esi			; set new IP
	next

core_header 07,_cbranch,"?branch",flag_none
_cbranch:
	lodsd				; eax = address to (maybe) jump to
	or	ebx,ebx			; is TOS true?
	pop	ebx			; drop
	jz	.false			; TOS wasn't true, skip jump
	xchg	eax,esi			; set new IP
.false:	next

core_header 24,_c0branch,"?0branch",flag_none
_c0branch:
	lodsd				; eax = address to (maybe) jump to
	or	ebx,ebx			; is TOS true?
	pop	ebx			; drop
	jnz	.false			; TOS was true, skip jump
	xchg	eax,esi			; set new IP
.false:	next

